// Reorderable Matrix by Mohit Hingorani Winter 2015

/* 

This is algorithmically the most complex in the class, future examples are much easier than this :)
The basic idea of a reordrable matrix is to reorder a 2D matrix based on a certian set of terms and conditions.
New insights into the data can be achieved when the data is moved around within the same table 

In 2D reorderable matrix, we order the matrix rowwise and column wise based on the total weight of the row and column
We sum of up every row and column and then bubble sort it in ascending or descending order.
Then we repeat the process for columns as well.

We do have the option of weighing each row and column like shown in the example but it may not be necessary. 
*/

// press r and c to get the row ordered matrix,column ordered matrix 
// n  for adding numbers

/*
SELECT
sum(CASE WHEN weekday(cout) = 0 THEN 1 ELSE 0 END) as Sunday,
sum(CASE WHEN weekday(cout) = 1 THEN 1 ELSE 0 END) as Monday,
sum(CASE WHEN weekday(cout) = 2 THEN 1 ELSE 0 END) as Tuesday,
sum(CASE WHEN weekday(cout) = 3 THEN 1 ELSE 0 END) as Wednesday,
sum(CASE WHEN weekday(cout) = 4 THEN 1 ELSE 0 END) as Thursday,
sum(CASE WHEN weekday(cout) = 5 THEN 1 ELSE 0 END) as Friday,
sum(CASE WHEN weekday(cout) = 6 THEN 1 ELSE 0 END) as Saturday

FROM spl2.inraw
WHERE itemtype LIKE "%bk"
AND year(cout)>= 2009 AND year(cout)<2013 
AND deweyClass is not null
group BY year(cout)
*/


PFont font = createFont("Helvetica Neau", 12, true);
// reorderable matrix example


int rows = 7;
int cols = 4;
int rectWidth  = 60;
int rectHeight = 100;
int Xmargin = 100;
int YMargin = 50;

//keeping track of rows
float[][] myArray = new float[rows][cols] ;
String [] days = { "Sunday" ,"Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday" };
String [] years = { "2009","2010","2011","2012" } ; 

String [] orderedDays = { "Sunday" ,"Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday" };;
String [] orderedYears = { "2009","2010","2011","2012" } ; 


//variables to store positions for the matrix etc
int originalPosition = 0;
int originalSumPosition = 360;
int colorCodedRows =300;
int rowOrderedArrayPosition  =750;
int rowOrderedSumPosition = 750;
int rowOrderinIndex = 400;

// arrays to store the weights, not necessary if the matrix is equally weighted like in this case
float [] columnWeights = { 1,1,1,1 } ;
float [] rowWeights = { 1,1,1,1,1,1,1 } ;

//float [] columnWeights = { 1,1,1,1} ;
//float [] rowWeights = { 1,1,1,1,1,1,1,1,1,1 } ;
//more arrays to keep track of reordered matrices
float [] sumOfRows = new float[ rows];
float [] CopyOfSumOfRows = new float[ rows];
float [] trackerOfRowChanges = new float[ rows];
float [] reorderedRows = new float[ rows];

float [] sumOfColumns = new float[ cols];
float [] CopyOfSumOfColumns = new float[ cols];
float [] trackerOfColumnChanges = new float[ cols];
float [] reorderedColumns = new float[ cols];

// storing 2D arrays
float [][] columnWeightedArray = new float[rows][cols];
float [][] rowWeightedArray = new float[rows][cols];
float [][] reorderedArray = new float[rows][cols];                     

float maxCount = 0 ;
Table myTable;
 
boolean ROFlag = false;
boolean COFlag = false;
boolean numbersFlag = false;
boolean sumRowFlag = false;

// declaring colors , makes it much easier to wrok with colors
color labelColor = color(64); 
color numberColor = color( 90,200,100);
